
const
 STOP_REASON_SIGHUP                                              = $00000001; // Stop caused by SIGHUP signal.
 STOP_REASON_SIGINT                                              = $00000002; // Stop caused by SIGINT signal.
 STOP_REASON_SIGQUIT                                             = $00000003; // Stop caused by SIGQUIT signal.
 STOP_REASON_SIGILL                                              = $00000004; // Stop caused by SIGILL signal.
 STOP_REASON_SIGTRAP                                             = $00000005; // Stop caused by SIGTRAP signal.
 STOP_REASON_SIGABRT                                             = $00000006; // Stop caused by SIGABRT signal.
 STOP_REASON_SIGEMT                                              = $00000007; // Stop caused by SIGEMT (emulator trap) signal.
 STOP_REASON_SIGFPE                                              = $00000008; // Stop caused by SIGFPE signal.
 STOP_REASON_SIGKILL                                             = $00000009; // Stop caused by SIGKILL signal.
 STOP_REASON_SIGBUS                                              = $0000000A; // Stop caused by SIGBUS signal.
 STOP_REASON_SIGSEGV                                             = $0000000B; // Stop caused by SIGSEGV signal.
 STOP_REASON_SIGSYS                                              = $0000000C; // Stop caused by SIGSYS signal.
 STOP_REASON_SIGPIPE                                             = $0000000D; // Stop caused by SIGPIPE signal.
 STOP_REASON_SIGALRM                                             = $0000000E; // Stop caused by SIGALRM signal.
 STOP_REASON_SIGTERM                                             = $0000000F; // Stop caused by SIGTERM signal.
 STOP_REASON_SIGURG                                              = $00000010; // Stop caused by SIGURG signal.
 STOP_REASON_SIGSTOP                                             = $00000011; // Stop caused by SIGSTOP signal.
 STOP_REASON_SIGTSTP                                             = $00000012; // Stop caused by SIGTSTP signal.
 STOP_REASON_SIGCONT                                             = $00000013; // Stop caused by SIGCONT signal.
 STOP_REASON_SIGCHLD                                             = $00000014; // Stop caused by SIGCHLD signal.
 STOP_REASON_SIGTTIN                                             = $00000015; // Stop caused by SIGTTIN signal.
 STOP_REASON_SIGTTOU                                             = $00000016; // Stop caused by SIGTTOU signal.
 STOP_REASON_SIGIO                                               = $00000017; // Stop caused by SIGIO (SIGPOLL) signal.
 STOP_REASON_SIGXCPU                                             = $00000018; // Stop caused by SIGXCPU signal.
 STOP_REASON_SIGXFSZ                                             = $00000019; // Stop caused by SIGXFSZ signal.
 STOP_REASON_SIGVTALRM                                           = $0000001A; // Stop caused by SIGVTALRM signal.
 STOP_REASON_SIGPROF                                             = $0000001B; // Stop caused by SIGPROF signal.
 STOP_REASON_SIGWINCH                                            = $0000001C; // Stop caused by SIGWINCH signal.
 STOP_REASON_SIGINFO                                             = $0000001D; // Stop caused by SIGINFO signal.
 STOP_REASON_SIGUSR1                                             = $0000001E; // Stop caused by SIGUSR1 signal.
 STOP_REASON_SIGUSR2                                             = $0000001F; // Stop caused by SIGUSR2 signal.
 STOP_REASON_SIGTHR                                              = $00000020; // Reserved by thread library.
 STOP_REASON_SIGNONE                                             = $00000080; // When this reason is used in IProcessInfo, it means the process is running. When this reason is used in IThreadInfo, it means the thread is running no matter what the process state is.
 STOP_REASON_SIGSUSPEND_PROCESS                                  = $00000081; // Stopped because SCE_DBGP_TYPE_SUSPEND_PROCESS_CMD was received, or the process was spawned with LOAD_OPTIONS_LOAD_SUSPENDED and has not been resumed.
 STOP_REASON_SIGSUSPEND_THREAD                                   = $00000082; // Stopped because SCE_DBGP_TYPE_SUSPEND_THREAD_CMD was received.
 STOP_REASON_SIGSWBRKPT                                          = $00000083; // Stopped due to hitting software breakpoint inserted with SET_SWBRKPT_CMD.
 STOP_REASON_DL_STOP_INIT                                        = $00000084; // Stopped due to loading dynamic module for the process when dlStop bit is set.
 STOP_REASON_DL_START_UP_FAILED                                  = $00000085; // error was encountered when preparing to start or on starting a dynamic library.
 STOP_REASON_SIGHWBRKPT                                          = $00000086; // Stopped due to hitting hardware breakpoint inserted with SET_HWBRKPT_CMD. Even though hardware breakpoints are not thread specific, only the thread that hit the breakpoint should have this reason.
 STOP_REASON_LIBC_RETURN_MAIN_SUCCESS                            = $a0020001; // Returned from main with zero.
 STOP_REASON_LIBC_RETURN_MAIN_FAIL                               = $a0020002; // Returned from main with non-zero.
 STOP_REASON_LIBC_EXIT_SUCCESS                                   = $a0020003; // exit is called with zero.
 STOP_REASON_LIBC_EXIT_FAIL                                      = $a0020004; // exit is called with non-zero.
 STOP_REASON_LIBC__EXIT_SUCCESS                                  = $a0020005; // _Exit is called with zero.
 STOP_REASON_LIBC__EXIT_FAIL                                     = $a0020006; // _Exit is called with non-zero.
 STOP_REASON_LIBC_ASSERT                                         = $a0020007; // assert is called.
 STOP_REASON_LIBC_TERMINATE                                      = $a0020008; // Terminate is called.
 STOP_REASON_LIBC_UNEXPECTED                                     = $a0020009; // unexpected is called.
 STOP_REASON_LIBC_PURE_VIRTUAL                                   = $a002000a; // pure virtual function is called.
 STOP_REASON_LIBC_ABORT                                          = $a002000b; // abort is called.
 STOP_REASON_LIBC_QUICK_EXIT_SUCCESS                             = $a002000c; // quick_exit is called with zero.
 STOP_REASON_LIBC_QUICK_EXIT_FAIL                                = $a002000d; // quick_exit is called with non-zero.
 STOP_REASON_LIBC_FAILED_TO_CREATE_HEAP                          = $a002000e; // Failed to create the heap. Please check the value of sceLibcHeapSize.
 STOP_REASON_LIBC_FAILED_TO_REPLACE_MALLOC                       = $a0020010; // Failed to replace malloc. Please check that you defined all necessary functions.
 STOP_REASON_LIBC_FAILED_TO_REPLACE_NEW                          = $a0020011; // Failed to replace new. Please check that you defined all necessary functions.
 STOP_REASON_LIBC_FAILED_TO_REPLACE_TLS_MALLOC                   = $a0020012; // Failed to replace malloc for TLS. Please check that you defined all necessary functions.
 STOP_REASON_LIBC_FAILED_TO_MALLOC_INIT                          = $a0020013; // Failed to initialize malloc.
 STOP_REASON_LIBC_FAILED_TO_TLS_MALLOC_INIT                      = $a0020014; // Failed to initialize malloc for TLS.
 STOP_REASON_LIBC_INTERNAL_RETURN_MAIN_SUCCESS                   = $a0020081; // Returned from main with zero(system).
 STOP_REASON_LIBC_INTERNAL_RETURN_MAIN_FAIL                      = $a0020082; // Returned from main with non-zero(system).
 STOP_REASON_LIBC_INTERNAL_EXIT_SUCCESS                          = $a0020083; // exit is called with zero(system).
 STOP_REASON_LIBC_INTERNAL_EXIT_FAIL                             = $a0020084; // exit is called with non-zero(system).
 STOP_REASON_LIBC_INTERNAL__EXIT_SUCCESS                         = $a0020085; // _Exit is called with zero(system).
 STOP_REASON_LIBC_INTERNAL__EXIT_FAIL                            = $a0020086; // _Exit is called with non-zero(system).
 STOP_REASON_LIBC_INTERNAL_ASSERT                                = $a0020087; // assert is called(system).
 STOP_REASON_LIBC_INTERNAL_TERMINATE                             = $a0020088; // Terminate is called(system).
 STOP_REASON_LIBC_INTERNAL_UNEXPECTED                            = $a0020089; // unexpected is called(system).
 STOP_REASON_LIBC_INTERNAL_PURE_VIRTUAL                          = $a002008a; // pure virtual function is called(system).
 STOP_REASON_LIBC_INTERNAL_ABORT                                 = $a002008b; // abort is called(system).
 STOP_REASON_LIBC_INTERNAL_QUICK_EXIT_SUCCESS                    = $a002008c; // quick_exit is called with zero(system).
 STOP_REASON_LIBC_INTERNAL_QUICK_EXIT_FAIL                       = $a002008d; // quick_exit is called with non-zero(system).
 STOP_REASON_LIBC_INTERNAL_FAILED_TO_CREATE_SYSTEM_MEMORY        = $a002008f; // Failed to create the system memory (please report it in devnet).
 STOP_REASON_PRX_NOT_RESOLVED_FUNCTION                           = $a0020101; // Called PRX function was not resolved.
 STOP_REASON_PRX_SCE_MODULE_LOAD_ERROR                           = $a0020102; // Cannot load necessary modules from sce_module.
 STOP_REASON_PRX_RUNTIME_ERROR                                   = $a0020103; // An error occured in dynamic library (PRX) runtime.
 STOP_REASON_PRX_PROCESS_STARTUP_FAILURE                         = $a0020104; // System software failed to initialize process environment.
 STOP_REASON_PRX_INVALID_IMAGE                                   = $a0020105; // The program loader detected a critical error in the executable file.
 STOP_REASON_PRX_TLS_ALLOC_ERROR                                 = $a0020106; // Dynamic library (PRX) runtime cannot allocate TLS.
 STOP_REASON_SYSTEM_FATAL_LOAD_ERROR                             = $a0020302; // System software could not start the program.
 STOP_REASON_SYSTEM_PTHREAD_RUNTIME_ERROR                        = $a0020305; // ScePthread runtime detected a fatal runtime error.
 STOP_REASON_SYSTEM_INTERNAL_PTHREAD_RUNTIME_ERROR               = $a0020306; // ScePthread runtime detected a fatal runtime error(internal).
 STOP_REASON_SYSTEM_STACK_CHECK_FAILURE                          = $a0020307; // System software detected user stack is corrupted.
 STOP_REASON_SYSTEM_INTERNAL_STACK_CHECK_FAILURE                 = $a0020308; // System software detected user stack is corrupted(internal).
 STOP_REASON_SYSTEM_UNKNOWN_FATAL_ERROR                          = $a0020309; // The process was forcibly terminated due to unknown fatal error.
 STOP_REASON_SYSTEM_ILLEGAL_FUNCTION_CALL                        = $a002030a; // The process was terminated with illegal function call.
 STOP_REASON_SYSTEM_SCE_BREAK                                    = $a002030b; // The process was terminated with unhandled SCE_BREAK.
 STOP_REASON_SYSTEM_SCE_STOP                                     = $a002030c; // The process was terminated with unhandled SCE_STOP.
 STOP_REASON_SYSTEM_UNKNOWN_KERNEL_ERROR                         = $a002030d; // System software forcibly shutdown the process(driver).
 STOP_REASON_SYSTEM_EXECUTABLE_ACCESS_ERROR                      = $a0020311; // Failed to verify executable.
 STOP_REASON_KERNEL_ABORT_SYSTEM_ABNORMAL_TERMINATION_REQUEST    = $a0020318; // The process terminated with sceSystemServiceReportAbnormalTermination.
 STOP_REASON_SYSTEM_INTERNAL_DATA_ACCESS_ERROR                   = $a0020319; // System software is corrupted.
 STOP_REASON_SYSTEM_ILLEGAL_EXCEPTION_CODE                       = $a002031a; // The process misused a library and was terminated.
 STOP_REASON_SYSTEM_INTERNAL_SERVICE_RUNTIME_ERROR               = $a002031c; // Failed to request system software service.
 STOP_REASON_SYSTEM_DEBUG_RUNTIME_ERROR                          = $a002031d; // Cannot continue process instrumentation.
 STOP_REASON_SYSTEM_INTERNAL_SERVICE_RUNTIME_FATAL               = $a002031e; // Failed to request system software service.
 STOP_REASON_SYSTEM_INTERNAL_SERVICE_CALL_ERROR                  = $a002031f; // Failed to request system software service.
 STOP_REASON_SYSTEM_INTERNAL_SERVICE_CALL_FATAL                  = $a0020320; // Failed to request system software service.
 STOP_REASON_SYSTEM_PTHREAD_MUTEX_ERROR                          = $a0020321; // Critical error on pthread mutex.
 STOP_REASON_SYSTEM_WRITE_ADDRESS_WRAPAROUND                     = $a0020323; // System software detected wraparound of write address.
 STOP_REASON_SYSTEM_ASAN_FATAL_ASSERT                            = $a0020325; // The process encountered a fatal ASan error.
 STOP_REASON_SYSTEM_IMAGE_ALLOC_ERROR                            = $a0020326; // process creation failure: The specified FMEM size is too small.
 STOP_REASON_SYSTEM_DEBUG_RUNTIME_SHADOW_MEMORY_ALLOW_ERROR      = $a0020327; // The process was terminated due to lack of memory for mapping the shadow memory for address sanitizer.
 STOP_REASON_SYSTEM_BAILOUT_REQUEST                              = $a0020404; // Terminating system service(s) without crash reporting. (Internal)
 STOP_REASON_SYSTEM_BAILOUT_LOW_MEMORY                           = $a0020405; // Terminating system service(s) without crash reporting. (Internal)
 STOP_REASON_SYSTEM_SUSPEND_BLOCK_TIMEOUT_ASYNC                  = $a0024301; // System software forcibly shutdown the process because of suspend blocker timeout.
 STOP_REASON_SYSTEM_UNKNOWN_FATAL_ERROR_ASYNC                    = $a0024303; // System software forcibly shutdown the process.
 STOP_REASON_SYSTEM_USER_DEBUG_REQUEST_ASYNC                     = $a0024304; // The process received debug termination request.
 STOP_REASON_SYSTEM_INTERNAL_SERVICE_TIMEOUT_ASYNC               = $a002431b; // Terminating system service(s). (Internal)
 STOP_REASON_SYSTEM_SOFTWARE_TIMEOUT_ASYNC                       = $a0024402; // The process was forcibly terminated with operation timeout.
 STOP_REASON_SYSTEM_BAILOUT_GENERIC_ASYNC                        = $a0024403; // Terminating system service(s) without crash reporting. (Internal)
 STOP_REASON_SYSTEM_DEBUGHANDLER_TIMEOUT                         = $a0028310; // The core dump handler timed out.
 STOP_REASON_SYSTEM_DEBUGHANDLER_REJECTED                        = $a0028316; // Core dump handler was skipped due to application suspend.
 STOP_REASON_SYSTEM_TRIGGER_COREDUMP_REQUEST                     = $a0028322; // The process requested coredump generation.
 STOP_REASON_SYSTEM_ASAN_ASSERT                                  = $a0028324; // The process encountered an ASan error.
 STOP_REASON_SYSTEM_VM_RUNTIME                                   = $a0028401; // The process was terminated with VM runtime exception.
 STOP_REASON_SYSTEM_DUMP_AND_CONTINUE_REQUEST_ASYNC              = $a002c315; // The process received coredump request.
 STOP_REASON_KERNEL_EXCEPTION_SYSTEM_DEBUG_REQUEST_TIMEOUT_ASYNC = $a002c317; // Debug suspend request was timed out.
 STOP_REASON_GPU_FAULT_ASYNC                                     = $a0d0c001; // GPU exception was detected.
 STOP_REASON_GPU_HP3D_TIMEOUT_ASYNC                              = $a0d04002; // System software forcibly shutdown the process because of GPU timeout.
 STOP_REASON_GPU_SUBMITDONE_TIMEOUT_ASYNC                        = $a0d04003; // System software forcibly shutdown the process because of submitDone timeout.
 STOP_REASON_GPU_BREAK_ASYNC                                     = $a0d0c004; /// GPU breakpoint detected.
 STOP_REASON_GPU_FAULT_PAGE_FAULT_ASYNC                          = $a0d0c005; // GPU page fault detected.
 STOP_REASON_GPU_FAULT_BAD_OP_CODE_ASYNC                         = $a0d0c006; // GPU encountered illegal instruction.
 STOP_REASON_GPU_FAULT_SUBMITDONE_TIMEOUT_IN_RUN_ASYNC           = $a0d0c007; // System software forcibly shutdown the process because of submitDone timeout. GPU was in busy state.
 STOP_REASON_GPU_FAULT_SUBMITDONE_TIMEOUT_IN_SUSPEND_ASYNC       = $a0d0c008; // System software failed to suspend the process because of submitDone timeout. GPU was in busy state.
 STOP_REASON_CPU_FAULT_SUBMITDONE_TIMEOUT_IN_RUN_ASYNC           = $a0d0c009; // System software forcibly shutdown the process because of submitDone timeout. GPU was in idle state.
 STOP_REASON_CPU_FAULT_SUBMITDONE_TIMEOUT_IN_SUSPEND_ASYNC       = $a0d0c00a; // System software failed to suspend the process because of submitDone timeout. GPU was in idle state.
 STOP_REASON_GPU_FAULT_IDLE_TIMEOUT_AFTER_SUBMITDONE_ASYNC       = $a0d0c00b; // GPU idle timeout after submitDone.
 STOP_REASON_SLV_MUTEX_UNLOCK_NOT_OWNED                          = $a0ff8301; // ScePthreadMutexUnlock() : Unlocking mutex that is not locked by the calling thread.
 STOP_REASON_SLV_POSIX_MUTEX_UNLOCK_NOT_OWNED                    = $a0ff8302; // pthread_mutex_unlock() : Unlocking mutex that is not locked by the calling thread.
 STOP_REASON_SLV_MUTEX_DESTROY_LOCKED                            = $a0ff8303; // ScePthreadMutexDestroy() : Destroying locked mutex.
 STOP_REASON_SLV_POSIX_MUTEX_DESTROY_LOCKED                      = $a0ff8304; // pthread_mutex_destroy() : Destroying locked mutex.
 STOP_REASON_SLV_MUTEX_LOCK_DESTROYED                            = $a0ff8305; // ScePthreadMutexLock() : Locking destroyed mutex.
 STOP_REASON_SLV_POSIX_MUTEX_LOCK_DESTROYED                      = $a0ff8306; // pthread_mutex_lock() : Locking destroyed mutex.
 STOP_REASON_SLV_CLOSE_NOT_PERMITTED_FD                          = $a0ff8307; // SceKernelClose() : Closing specified fd is not permitted.
 STOP_REASON_SLV_POSIX_CLOSE_NOT_PERMITTED_FD                    = $a0ff8308; // close() : Closing specified fd is not permitted.
 STOP_REASON_SLV_MUTEX_DESTROY_DESTROYED                         = $a0ff8309; // ScePthreadMutexDestroy() : Destroying destroyed mutex.
 STOP_REASON_SLV_POSIX_MUTEX_DESTROY_DESTROYED                   = $a0ff830a; // pthread_mutex_destroy() : Destroying destroyed mutex.
 STOP_REASON_SLV_MUTEX_TIMEDLOCK_DESTROYED                       = $a0ff830b; // ScePthreadMutexTimedlock() : Locking destroyed mutex (with timeout).
 STOP_REASON_SLV_MUTEX_TRYLOCK_DESTROYED                         = $a0ff830c; // ScePthreadMutexTrylock() : Trying to lock destroyed mutex.
 STOP_REASON_SLV_POSIX_MUTEX_TRYLOCK_DESTROYED                   = $a0ff830d; // pthread_mutex_trylock() : Trying to lock destroyed mutex.
 STOP_REASON_SLV_MUTEX_UNLOCK_DESTROYED                          = $a0ff830e; // ScePthreadMutexUnlock() : Unlocking destroyed mutex.
 STOP_REASON_SLV_POSIX_MUTEX_UNLOCK_DESTROYED                    = $a0ff830f; // pthread_mutex_unlock() : Unlocking destroyed mutex.
 STOP_REASON_SLV_COND_BROADCAST_DESTROYED                        = $a0ff8310; // ScePthreadCondBroadcast() : Broadcasting destroyed condition variable.
 STOP_REASON_SLV_POSIX_COND_BROADCAST_DESTROYED                  = $a0ff8311; // pthread_cond_broadcast() : Broadcasting destroyed condition variable.
 STOP_REASON_SLV_COND_DESTROY_DESTROYED                          = $a0ff8312; // ScePthreadCondDestroy() : Destroying destroyed condition variable.
 STOP_REASON_SLV_POSIX_COND_DESTROY_DESTROYED                    = $a0ff8313; // pthread_cond_destroy() : Destroying destroyed condition variable.
 STOP_REASON_SLV_COND_SIGNAL_DESTROYED                           = $a0ff8314; // ScePthreadCondSignal() : Signaling destroyed condition variable.
 STOP_REASON_SLV_POSIX_COND_SIGNAL_DESTROYED                     = $a0ff8315; // pthread_cond_signal() : Signaling destroyed condition variable.
 STOP_REASON_SLV_COND_SIGNALTO_DESTROYED                         = $a0ff8316; // ScePthreadCondSignalto() : Signaling destroyed condition variable (specific thread).
 STOP_REASON_SLV_COND_TIMEDWAIT_DESTROYED                        = $a0ff8317; // ScePthreadCondTimedwait() : Waiting destroyed condition variable (with timeout).
 STOP_REASON_SLV_COND_TIMEDWAIT_MUTEX_NOT_OWNED                  = $a0ff8318; // ScePthreadCondTimedwait() : Mutex is not locked by the calling thread.
 STOP_REASON_SLV_POSIX_COND_TIMEDWAIT_MUTEX_NOT_OWNED            = $a0ff8319; // pthread_cond_timedwait() : Mutex is not locked by the calling thread.
 STOP_REASON_SLV_COND_WAIT_DESTROYED                             = $a0ff831a; // ScePthreadCondWait() : Waiting destroyed condition variable.
 STOP_REASON_SLV_POSIX_COND_WAIT_DESTROYED                       = $a0ff831b; // pthread_cond_wait() : Waiting destroyed condition variable.
 STOP_REASON_SLV_COND_WAIT_MUTEX_NOT_OWNED                       = $a0ff831c; // ScePthreadCondWait() : mutex is not locked by the calling thread.
 STOP_REASON_SLV_POSIX_COND_WAIT_MUTEX_NOT_OWNED                 = $a0ff831d; // pthread_cond_wait() : Mutex is not locked by the calling thread.
 STOP_REASON_SLV_RWLOCK_DESTROY_DESTROYED                        = $a0ff831e; // ScePthreadRwlockDestroy() : Destroying destroyed read / write lock.
 STOP_REASON_SLV_POSIX_RWLOCK_DESTROY_DESTROYED                  = $a0ff831f; // pthread_rwlock_destroy() : Destroying destroyed read / write lock.
 STOP_REASON_SLV_RWLOCK_RDLOCK_DESTROYED                         = $a0ff8320; // ScePthreadRwlockRdlock() : Locking destroyed read / write lock (for reading).
 STOP_REASON_SLV_POSIX_RWLOCK_RDLOCK_DESTROYED                   = $a0ff8321; // pthread_rwlock_rdlock() : Locking destroyed read / write lock (for reading).
 STOP_REASON_SLV_RWLOCK_TIMEDRDLOCK_DESTROYED                    = $a0ff8322; // ScePthreadRwlockTimedrdlock() : Locking destroyed read / write lock (for reading, with timeout).
 STOP_REASON_SLV_RWLOCK_TIMEDWRLOCK_DESTROYED                    = $a0ff8323; // ScePthreadRwlockTimedwrlock() : Locking destroyed read / write lock (for writing, with timeout).
 STOP_REASON_SLV_RWLOCK_TRYRDLOCK_DESTROYED                      = $a0ff8324; // ScePthreadRwlockTryrdlock() : Trying to lock destroyed read / write lock (for reading).
 STOP_REASON_SLV_POSIX_RWLOCK_TRYRDLOCK_DESTROYED                = $a0ff8325; // pthread_rwlock_tryrdlock() : Trying to lock destroyed read / write lock (for reading).
 STOP_REASON_SLV_RWLOCK_TRYWRLOCK_DESTROYED                      = $a0ff8326; // ScePthreadRwlockTrywrlock() : Trying to lock destroyed read / write lock (for writing).
 STOP_REASON_SLV_POSIX_RWLOCK_TRYWRLOCK_DESTROYED                = $a0ff8327; // pthread_rwlock_trywrlock() : Trying to lock destroyed read / write lock (for writing).
 STOP_REASON_SLV_RWLOCK_UNLOCK_DESTROYED                         = $a0ff8328; // ScePthreadRwlockUnlock() : Unlocking destroyed read / write lock.
 STOP_REASON_SLV_POSIX_RWLOCK_UNLOCK_DESTROYED                   = $a0ff8329; // pthread_rwlock_unlock() : Unlocking destroyed read / write lock.
 STOP_REASON_SLV_RWLOCK_UNLOCK_NOT_OWNED                         = $a0ff832a; // ScePthreadRwlockUnlock() : Read / write lock is not locked by the calling thread.
 STOP_REASON_SLV_POSIX_RWLOCK_UNLOCK_NOT_OWNED                   = $a0ff832b; // pthread_rwlock_unlock() : Read / write lock is not locked by the calling thread.
 STOP_REASON_SLV_RWLOCK_WRLOCK_DESTROYED                         = $a0ff832c; // ScePthreadRwlockWrlock() : Locking destroyed read / write lock (for writing).
 STOP_REASON_SLV_POSIX_RWLOCK_WRLOCK_DESTROYED                   = $a0ff832d; // pthread_rwlock_wrlock() : Locking destroyed read / write lock (for writing).
 STOP_REASON_SLV_BARRIER_DESTROY_DESTROYED                       = $a0ff832e; // ScePthreadBarrierDestroy() : Destroying destroyed barrier.
 STOP_REASON_SLV_POSIX_BARRIER_DESTROY_DESTROYED                 = $a0ff832f; // pthread_barrier_destroy() : Destroying destroyed barrier.
 STOP_REASON_SLV_BARRIER_DESTROY_IN_USE                          = $a0ff8330; // ScePthreadBarrierDestroy() : Destroying barrier that is being used by any one of the threads.
 STOP_REASON_SLV_POSIX_BARRIER_DESTROY_IN_USE                    = $a0ff8331; // pthread_barrier_destroy() : Destroying barrier that is being used by any one of the threads.
 STOP_REASON_SLV_BARRIER_WAIT_DESTROYED                          = $a0ff8332; // ScePthreadBarrierWait() : Waiting destroyed barrier.
 STOP_REASON_SLV_POSIX_BARRIER_WAIT_DESTROYED                    = $a0ff8333; // pthread_barrier_wait() : Waiting destroyed barrier.
 STOP_REASON_SLV_POSIX_MUTEX_TIMEDLOCK_DESTROYED                 = $a0ff8334; // Specified mutex is not valid.
 STOP_REASON_SLV_POSIX_COND_TIMEDWAIT_DESTROYED                  = $a0ff8335; // Specified condition variable is not valid.
 STOP_REASON_SLV_POSIX_RWLOCK_TIMEDRDLOCK_DESTROYED              = $a0ff8336; // Specified read / write lock is not valid.
 STOP_REASON_SLV_POSIX_RWLOCK_TIMEDWRLOCK_DESTROYED              = $a0ff8337; // Specified read / write lock is not valid.

function GetStopReasonInfo(dwStopReason:DWORD):RawByteString;
begin
 Case dwStopReason of
  STOP_REASON_SIGHUP                                             :Result:='Stop caused by SIGHUP signal.';
  STOP_REASON_SIGINT                                             :Result:='Stop caused by SIGINT signal.';
  STOP_REASON_SIGQUIT                                            :Result:='Stop caused by SIGQUIT signal.';
  STOP_REASON_SIGILL                                             :Result:='Stop caused by SIGILL signal.';
  STOP_REASON_SIGTRAP                                            :Result:='Stop caused by SIGTRAP signal.';
  STOP_REASON_SIGABRT                                            :Result:='Stop caused by SIGABRT signal.';
  STOP_REASON_SIGEMT                                             :Result:='Stop caused by SIGEMT (emulator trap) signal.';
  STOP_REASON_SIGFPE                                             :Result:='Stop caused by SIGFPE signal.';
  STOP_REASON_SIGKILL                                            :Result:='Stop caused by SIGKILL signal.';
  STOP_REASON_SIGBUS                                             :Result:='Stop caused by SIGBUS signal.';
  STOP_REASON_SIGSEGV                                            :Result:='Stop caused by SIGSEGV signal.';
  STOP_REASON_SIGSYS                                             :Result:='Stop caused by SIGSYS signal.';
  STOP_REASON_SIGPIPE                                            :Result:='Stop caused by SIGPIPE signal.';
  STOP_REASON_SIGALRM                                            :Result:='Stop caused by SIGALRM signal.';
  STOP_REASON_SIGTERM                                            :Result:='Stop caused by SIGTERM signal.';
  STOP_REASON_SIGURG                                             :Result:='Stop caused by SIGURG signal.';
  STOP_REASON_SIGSTOP                                            :Result:='Stop caused by SIGSTOP signal.';
  STOP_REASON_SIGTSTP                                            :Result:='Stop caused by SIGTSTP signal.';
  STOP_REASON_SIGCONT                                            :Result:='Stop caused by SIGCONT signal.';
  STOP_REASON_SIGCHLD                                            :Result:='Stop caused by SIGCHLD signal.';
  STOP_REASON_SIGTTIN                                            :Result:='Stop caused by SIGTTIN signal.';
  STOP_REASON_SIGTTOU                                            :Result:='Stop caused by SIGTTOU signal.';
  STOP_REASON_SIGIO                                              :Result:='Stop caused by SIGIO (SIGPOLL) signal.';
  STOP_REASON_SIGXCPU                                            :Result:='Stop caused by SIGXCPU signal.';
  STOP_REASON_SIGXFSZ                                            :Result:='Stop caused by SIGXFSZ signal.';
  STOP_REASON_SIGVTALRM                                          :Result:='Stop caused by SIGVTALRM signal.';
  STOP_REASON_SIGPROF                                            :Result:='Stop caused by SIGPROF signal.';
  STOP_REASON_SIGWINCH                                           :Result:='Stop caused by SIGWINCH signal.';
  STOP_REASON_SIGINFO                                            :Result:='Stop caused by SIGINFO signal.';
  STOP_REASON_SIGUSR1                                            :Result:='Stop caused by SIGUSR1 signal.';
  STOP_REASON_SIGUSR2                                            :Result:='Stop caused by SIGUSR2 signal.';
  STOP_REASON_SIGTHR                                             :Result:='Reserved by thread library.';
  STOP_REASON_SIGNONE                                            :Result:='When this reason is used in IProcessInfo, it means the process is running. When this reason is used in IThreadInfo, it means the thread is running no matter what the process state is.';
  STOP_REASON_SIGSUSPEND_PROCESS                                 :Result:='Stopped because SCE_DBGP_TYPE_SUSPEND_PROCESS_CMD was received, or the process was spawned with LOAD_OPTIONS_LOAD_SUSPENDED and has not been resumed.';
  STOP_REASON_SIGSUSPEND_THREAD                                  :Result:='Stopped because SCE_DBGP_TYPE_SUSPEND_THREAD_CMD was received.';
  STOP_REASON_SIGSWBRKPT                                         :Result:='Stopped due to hitting software breakpoint inserted with SET_SWBRKPT_CMD.';
  STOP_REASON_DL_STOP_INIT                                       :Result:='Stopped due to loading dynamic module for the process when dlStop bit is set.';
  STOP_REASON_DL_START_UP_FAILED                                 :Result:='error was encountered when preparing to start or on starting a dynamic library.';
  STOP_REASON_SIGHWBRKPT                                         :Result:='Stopped due to hitting hardware breakpoint inserted with SET_HWBRKPT_CMD. Even though hardware breakpoints are not thread specific, only the thread that hit the breakpoint should have this reason.';
  STOP_REASON_LIBC_RETURN_MAIN_SUCCESS                           :Result:='Returned from main with zero.';
  STOP_REASON_LIBC_RETURN_MAIN_FAIL                              :Result:='Returned from main with non-zero.';
  STOP_REASON_LIBC_EXIT_SUCCESS                                  :Result:='exit is called with zero.';
  STOP_REASON_LIBC_EXIT_FAIL                                     :Result:='exit is called with non-zero.';
  STOP_REASON_LIBC__EXIT_SUCCESS                                 :Result:='_Exit is called with zero.';
  STOP_REASON_LIBC__EXIT_FAIL                                    :Result:='_Exit is called with non-zero.';
  STOP_REASON_LIBC_ASSERT                                        :Result:='assert is called.';
  STOP_REASON_LIBC_TERMINATE                                     :Result:='Terminate is called.';
  STOP_REASON_LIBC_UNEXPECTED                                    :Result:='unexpected is called.';
  STOP_REASON_LIBC_PURE_VIRTUAL                                  :Result:='pure virtual function is called.';
  STOP_REASON_LIBC_ABORT                                         :Result:='abort is called.';
  STOP_REASON_LIBC_QUICK_EXIT_SUCCESS                            :Result:='quick_exit is called with zero.';
  STOP_REASON_LIBC_QUICK_EXIT_FAIL                               :Result:='quick_exit is called with non-zero.';
  STOP_REASON_LIBC_FAILED_TO_CREATE_HEAP                         :Result:='Failed to create the heap. Please check the value of sceLibcHeapSize.';
  STOP_REASON_LIBC_FAILED_TO_REPLACE_MALLOC                      :Result:='Failed to replace malloc. Please check that you defined all necessary functions.';
  STOP_REASON_LIBC_FAILED_TO_REPLACE_NEW                         :Result:='Failed to replace new. Please check that you defined all necessary functions.';
  STOP_REASON_LIBC_FAILED_TO_REPLACE_TLS_MALLOC                  :Result:='Failed to replace malloc for TLS. Please check that you defined all necessary functions.';
  STOP_REASON_LIBC_FAILED_TO_MALLOC_INIT                         :Result:='Failed to initialize malloc.';
  STOP_REASON_LIBC_FAILED_TO_TLS_MALLOC_INIT                     :Result:='Failed to initialize malloc for TLS.';
  STOP_REASON_LIBC_INTERNAL_RETURN_MAIN_SUCCESS                  :Result:='Returned from main with zero(system).';
  STOP_REASON_LIBC_INTERNAL_RETURN_MAIN_FAIL                     :Result:='Returned from main with non-zero(system).';
  STOP_REASON_LIBC_INTERNAL_EXIT_SUCCESS                         :Result:='exit is called with zero(system).';
  STOP_REASON_LIBC_INTERNAL_EXIT_FAIL                            :Result:='exit is called with non-zero(system).';
  STOP_REASON_LIBC_INTERNAL__EXIT_SUCCESS                        :Result:='_Exit is called with zero(system).';
  STOP_REASON_LIBC_INTERNAL__EXIT_FAIL                           :Result:='_Exit is called with non-zero(system).';
  STOP_REASON_LIBC_INTERNAL_ASSERT                               :Result:='assert is called(system).';
  STOP_REASON_LIBC_INTERNAL_TERMINATE                            :Result:='Terminate is called(system).';
  STOP_REASON_LIBC_INTERNAL_UNEXPECTED                           :Result:='unexpected is called(system).';
  STOP_REASON_LIBC_INTERNAL_PURE_VIRTUAL                         :Result:='pure virtual function is called(system).';
  STOP_REASON_LIBC_INTERNAL_ABORT                                :Result:='abort is called(system).';
  STOP_REASON_LIBC_INTERNAL_QUICK_EXIT_SUCCESS                   :Result:='quick_exit is called with zero(system).';
  STOP_REASON_LIBC_INTERNAL_QUICK_EXIT_FAIL                      :Result:='quick_exit is called with non-zero(system).';
  STOP_REASON_LIBC_INTERNAL_FAILED_TO_CREATE_SYSTEM_MEMORY       :Result:='Failed to create the system memory (please report it in devnet).';
  STOP_REASON_PRX_NOT_RESOLVED_FUNCTION                          :Result:='Called PRX function was not resolved.';
  STOP_REASON_PRX_SCE_MODULE_LOAD_ERROR                          :Result:='Cannot load necessary modules from sce_module.';
  STOP_REASON_PRX_RUNTIME_ERROR                                  :Result:='An error occured in dynamic library (PRX) runtime.';
  STOP_REASON_PRX_PROCESS_STARTUP_FAILURE                        :Result:='System software failed to initialize process environment.';
  STOP_REASON_PRX_INVALID_IMAGE                                  :Result:='The program loader detected a critical error in the executable file.';
  STOP_REASON_PRX_TLS_ALLOC_ERROR                                :Result:='Dynamic library (PRX) runtime cannot allocate TLS.';
  STOP_REASON_SYSTEM_FATAL_LOAD_ERROR                            :Result:='System software could not start the program.';
  STOP_REASON_SYSTEM_PTHREAD_RUNTIME_ERROR                       :Result:='ScePthread runtime detected a fatal runtime error.';
  STOP_REASON_SYSTEM_INTERNAL_PTHREAD_RUNTIME_ERROR              :Result:='ScePthread runtime detected a fatal runtime error(internal).';
  STOP_REASON_SYSTEM_STACK_CHECK_FAILURE                         :Result:='System software detected user stack is corrupted.';
  STOP_REASON_SYSTEM_INTERNAL_STACK_CHECK_FAILURE                :Result:='System software detected user stack is corrupted(internal).';
  STOP_REASON_SYSTEM_UNKNOWN_FATAL_ERROR                         :Result:='The process was forcibly terminated due to unknown fatal error.';
  STOP_REASON_SYSTEM_ILLEGAL_FUNCTION_CALL                       :Result:='The process was terminated with illegal function call.';
  STOP_REASON_SYSTEM_SCE_BREAK                                   :Result:='The process was terminated with unhandled SCE_BREAK.';
  STOP_REASON_SYSTEM_SCE_STOP                                    :Result:='The process was terminated with unhandled SCE_STOP.';
  STOP_REASON_SYSTEM_UNKNOWN_KERNEL_ERROR                        :Result:='System software forcibly shutdown the process(driver).';
  STOP_REASON_SYSTEM_EXECUTABLE_ACCESS_ERROR                     :Result:='Failed to verify executable.';
  STOP_REASON_KERNEL_ABORT_SYSTEM_ABNORMAL_TERMINATION_REQUEST   :Result:='The process terminated with sceSystemServiceReportAbnormalTermination.';
  STOP_REASON_SYSTEM_INTERNAL_DATA_ACCESS_ERROR                  :Result:='System software is corrupted.';
  STOP_REASON_SYSTEM_ILLEGAL_EXCEPTION_CODE                      :Result:='The process misused a library and was terminated.';
  STOP_REASON_SYSTEM_INTERNAL_SERVICE_RUNTIME_ERROR              :Result:='Failed to request system software service.';
  STOP_REASON_SYSTEM_DEBUG_RUNTIME_ERROR                         :Result:='Cannot continue process instrumentation.';
  STOP_REASON_SYSTEM_INTERNAL_SERVICE_RUNTIME_FATAL              :Result:='Failed to request system software service.';
  STOP_REASON_SYSTEM_INTERNAL_SERVICE_CALL_ERROR                 :Result:='Failed to request system software service.';
  STOP_REASON_SYSTEM_INTERNAL_SERVICE_CALL_FATAL                 :Result:='Failed to request system software service.';
  STOP_REASON_SYSTEM_PTHREAD_MUTEX_ERROR                         :Result:='Critical error on pthread mutex.';
  STOP_REASON_SYSTEM_WRITE_ADDRESS_WRAPAROUND                    :Result:='System software detected wraparound of write address.';
  STOP_REASON_SYSTEM_ASAN_FATAL_ASSERT                           :Result:='The process encountered a fatal ASan error.';
  STOP_REASON_SYSTEM_IMAGE_ALLOC_ERROR                           :Result:='process creation failure: The specified FMEM size is too small.';
  STOP_REASON_SYSTEM_DEBUG_RUNTIME_SHADOW_MEMORY_ALLOW_ERROR     :Result:='The process was terminated due to lack of memory for mapping the shadow memory for address sanitizer.';
  STOP_REASON_SYSTEM_BAILOUT_REQUEST                             :Result:='Terminating system service(s) without crash reporting. (Internal)';
  STOP_REASON_SYSTEM_BAILOUT_LOW_MEMORY                          :Result:='Terminating system service(s) without crash reporting. (Internal)';
  STOP_REASON_SYSTEM_SUSPEND_BLOCK_TIMEOUT_ASYNC                 :Result:='System software forcibly shutdown the process because of suspend blocker timeout.';
  STOP_REASON_SYSTEM_UNKNOWN_FATAL_ERROR_ASYNC                   :Result:='System software forcibly shutdown the process.';
  STOP_REASON_SYSTEM_USER_DEBUG_REQUEST_ASYNC                    :Result:='The process received debug termination request.';
  STOP_REASON_SYSTEM_INTERNAL_SERVICE_TIMEOUT_ASYNC              :Result:='Terminating system service(s). (Internal)';
  STOP_REASON_SYSTEM_SOFTWARE_TIMEOUT_ASYNC                      :Result:='The process was forcibly terminated with operation timeout.';
  STOP_REASON_SYSTEM_BAILOUT_GENERIC_ASYNC                       :Result:='Terminating system service(s) without crash reporting. (Internal)';
  STOP_REASON_SYSTEM_DEBUGHANDLER_TIMEOUT                        :Result:='The core dump handler timed out.';
  STOP_REASON_SYSTEM_DEBUGHANDLER_REJECTED                       :Result:='Core dump handler was skipped due to application suspend.';
  STOP_REASON_SYSTEM_TRIGGER_COREDUMP_REQUEST                    :Result:='The process requested coredump generation.';
  STOP_REASON_SYSTEM_ASAN_ASSERT                                 :Result:='The process encountered an ASan error.';
  STOP_REASON_SYSTEM_VM_RUNTIME                                  :Result:='The process was terminated with VM runtime exception.';
  STOP_REASON_SYSTEM_DUMP_AND_CONTINUE_REQUEST_ASYNC             :Result:='The process received coredump request.';
  STOP_REASON_KERNEL_EXCEPTION_SYSTEM_DEBUG_REQUEST_TIMEOUT_ASYNC:Result:='Debug suspend request was timed out.';
  STOP_REASON_GPU_FAULT_ASYNC                                    :Result:='GPU exception was detected.';
  STOP_REASON_GPU_HP3D_TIMEOUT_ASYNC                             :Result:='System software forcibly shutdown the process because of GPU timeout.';
  STOP_REASON_GPU_SUBMITDONE_TIMEOUT_ASYNC                       :Result:='System software forcibly shutdown the process because of submitDone timeout.';
  STOP_REASON_GPU_BREAK_ASYNC                                    :Result:=' GPU breakpoint detected.';
  STOP_REASON_GPU_FAULT_PAGE_FAULT_ASYNC                         :Result:='GPU page fault detected.';
  STOP_REASON_GPU_FAULT_BAD_OP_CODE_ASYNC                        :Result:='GPU encountered illegal instruction.';
  STOP_REASON_GPU_FAULT_SUBMITDONE_TIMEOUT_IN_RUN_ASYNC          :Result:='System software forcibly shutdown the process because of submitDone timeout. GPU was in busy state.';
  STOP_REASON_GPU_FAULT_SUBMITDONE_TIMEOUT_IN_SUSPEND_ASYNC      :Result:='System software failed to suspend the process because of submitDone timeout. GPU was in busy state.';
  STOP_REASON_CPU_FAULT_SUBMITDONE_TIMEOUT_IN_RUN_ASYNC          :Result:='System software forcibly shutdown the process because of submitDone timeout. GPU was in idle state.';
  STOP_REASON_CPU_FAULT_SUBMITDONE_TIMEOUT_IN_SUSPEND_ASYNC      :Result:='System software failed to suspend the process because of submitDone timeout. GPU was in idle state.';
  STOP_REASON_GPU_FAULT_IDLE_TIMEOUT_AFTER_SUBMITDONE_ASYNC      :Result:='GPU idle timeout after submitDone.';
  STOP_REASON_SLV_MUTEX_UNLOCK_NOT_OWNED                         :Result:='ScePthreadMutexUnlock() : Unlocking mutex that is not locked by the calling thread.';
  STOP_REASON_SLV_POSIX_MUTEX_UNLOCK_NOT_OWNED                   :Result:='pthread_mutex_unlock() : Unlocking mutex that is not locked by the calling thread.';
  STOP_REASON_SLV_MUTEX_DESTROY_LOCKED                           :Result:='ScePthreadMutexDestroy() : Destroying locked mutex.';
  STOP_REASON_SLV_POSIX_MUTEX_DESTROY_LOCKED                     :Result:='pthread_mutex_destroy() : Destroying locked mutex.';
  STOP_REASON_SLV_MUTEX_LOCK_DESTROYED                           :Result:='ScePthreadMutexLock() : Locking destroyed mutex.';
  STOP_REASON_SLV_POSIX_MUTEX_LOCK_DESTROYED                     :Result:='pthread_mutex_lock() : Locking destroyed mutex.';
  STOP_REASON_SLV_CLOSE_NOT_PERMITTED_FD                         :Result:='SceKernelClose() : Closing specified fd is not permitted.';
  STOP_REASON_SLV_POSIX_CLOSE_NOT_PERMITTED_FD                   :Result:='close() : Closing specified fd is not permitted.';
  STOP_REASON_SLV_MUTEX_DESTROY_DESTROYED                        :Result:='ScePthreadMutexDestroy() : Destroying destroyed mutex.';
  STOP_REASON_SLV_POSIX_MUTEX_DESTROY_DESTROYED                  :Result:='pthread_mutex_destroy() : Destroying destroyed mutex.';
  STOP_REASON_SLV_MUTEX_TIMEDLOCK_DESTROYED                      :Result:='ScePthreadMutexTimedlock() : Locking destroyed mutex (with timeout).';
  STOP_REASON_SLV_MUTEX_TRYLOCK_DESTROYED                        :Result:='ScePthreadMutexTrylock() : Trying to lock destroyed mutex.';
  STOP_REASON_SLV_POSIX_MUTEX_TRYLOCK_DESTROYED                  :Result:='pthread_mutex_trylock() : Trying to lock destroyed mutex.';
  STOP_REASON_SLV_MUTEX_UNLOCK_DESTROYED                         :Result:='ScePthreadMutexUnlock() : Unlocking destroyed mutex.';
  STOP_REASON_SLV_POSIX_MUTEX_UNLOCK_DESTROYED                   :Result:='pthread_mutex_unlock() : Unlocking destroyed mutex.';
  STOP_REASON_SLV_COND_BROADCAST_DESTROYED                       :Result:='ScePthreadCondBroadcast() : Broadcasting destroyed condition variable.';
  STOP_REASON_SLV_POSIX_COND_BROADCAST_DESTROYED                 :Result:='pthread_cond_broadcast() : Broadcasting destroyed condition variable.';
  STOP_REASON_SLV_COND_DESTROY_DESTROYED                         :Result:='ScePthreadCondDestroy() : Destroying destroyed condition variable.';
  STOP_REASON_SLV_POSIX_COND_DESTROY_DESTROYED                   :Result:='pthread_cond_destroy() : Destroying destroyed condition variable.';
  STOP_REASON_SLV_COND_SIGNAL_DESTROYED                          :Result:='ScePthreadCondSignal() : Signaling destroyed condition variable.';
  STOP_REASON_SLV_POSIX_COND_SIGNAL_DESTROYED                    :Result:='pthread_cond_signal() : Signaling destroyed condition variable.';
  STOP_REASON_SLV_COND_SIGNALTO_DESTROYED                        :Result:='ScePthreadCondSignalto() : Signaling destroyed condition variable (specific thread).';
  STOP_REASON_SLV_COND_TIMEDWAIT_DESTROYED                       :Result:='ScePthreadCondTimedwait() : Waiting destroyed condition variable (with timeout).';
  STOP_REASON_SLV_COND_TIMEDWAIT_MUTEX_NOT_OWNED                 :Result:='ScePthreadCondTimedwait() : Mutex is not locked by the calling thread.';
  STOP_REASON_SLV_POSIX_COND_TIMEDWAIT_MUTEX_NOT_OWNED           :Result:='pthread_cond_timedwait() : Mutex is not locked by the calling thread.';
  STOP_REASON_SLV_COND_WAIT_DESTROYED                            :Result:='ScePthreadCondWait() : Waiting destroyed condition variable.';
  STOP_REASON_SLV_POSIX_COND_WAIT_DESTROYED                      :Result:='pthread_cond_wait() : Waiting destroyed condition variable.';
  STOP_REASON_SLV_COND_WAIT_MUTEX_NOT_OWNED                      :Result:='ScePthreadCondWait() : mutex is not locked by the calling thread.';
  STOP_REASON_SLV_POSIX_COND_WAIT_MUTEX_NOT_OWNED                :Result:='pthread_cond_wait() : Mutex is not locked by the calling thread.';
  STOP_REASON_SLV_RWLOCK_DESTROY_DESTROYED                       :Result:='ScePthreadRwlockDestroy() : Destroying destroyed read / write lock.';
  STOP_REASON_SLV_POSIX_RWLOCK_DESTROY_DESTROYED                 :Result:='pthread_rwlock_destroy() : Destroying destroyed read / write lock.';
  STOP_REASON_SLV_RWLOCK_RDLOCK_DESTROYED                        :Result:='ScePthreadRwlockRdlock() : Locking destroyed read / write lock (for reading).';
  STOP_REASON_SLV_POSIX_RWLOCK_RDLOCK_DESTROYED                  :Result:='pthread_rwlock_rdlock() : Locking destroyed read / write lock (for reading).';
  STOP_REASON_SLV_RWLOCK_TIMEDRDLOCK_DESTROYED                   :Result:='ScePthreadRwlockTimedrdlock() : Locking destroyed read / write lock (for reading, with timeout).';
  STOP_REASON_SLV_RWLOCK_TIMEDWRLOCK_DESTROYED                   :Result:='ScePthreadRwlockTimedwrlock() : Locking destroyed read / write lock (for writing, with timeout).';
  STOP_REASON_SLV_RWLOCK_TRYRDLOCK_DESTROYED                     :Result:='ScePthreadRwlockTryrdlock() : Trying to lock destroyed read / write lock (for reading).';
  STOP_REASON_SLV_POSIX_RWLOCK_TRYRDLOCK_DESTROYED               :Result:='pthread_rwlock_tryrdlock() : Trying to lock destroyed read / write lock (for reading).';
  STOP_REASON_SLV_RWLOCK_TRYWRLOCK_DESTROYED                     :Result:='ScePthreadRwlockTrywrlock() : Trying to lock destroyed read / write lock (for writing).';
  STOP_REASON_SLV_POSIX_RWLOCK_TRYWRLOCK_DESTROYED               :Result:='pthread_rwlock_trywrlock() : Trying to lock destroyed read / write lock (for writing).';
  STOP_REASON_SLV_RWLOCK_UNLOCK_DESTROYED                        :Result:='ScePthreadRwlockUnlock() : Unlocking destroyed read / write lock.';
  STOP_REASON_SLV_POSIX_RWLOCK_UNLOCK_DESTROYED                  :Result:='pthread_rwlock_unlock() : Unlocking destroyed read / write lock.';
  STOP_REASON_SLV_RWLOCK_UNLOCK_NOT_OWNED                        :Result:='ScePthreadRwlockUnlock() : Read / write lock is not locked by the calling thread.';
  STOP_REASON_SLV_POSIX_RWLOCK_UNLOCK_NOT_OWNED                  :Result:='pthread_rwlock_unlock() : Read / write lock is not locked by the calling thread.';
  STOP_REASON_SLV_RWLOCK_WRLOCK_DESTROYED                        :Result:='ScePthreadRwlockWrlock() : Locking destroyed read / write lock (for writing).';
  STOP_REASON_SLV_POSIX_RWLOCK_WRLOCK_DESTROYED                  :Result:='pthread_rwlock_wrlock() : Locking destroyed read / write lock (for writing).';
  STOP_REASON_SLV_BARRIER_DESTROY_DESTROYED                      :Result:='ScePthreadBarrierDestroy() : Destroying destroyed barrier.';
  STOP_REASON_SLV_POSIX_BARRIER_DESTROY_DESTROYED                :Result:='pthread_barrier_destroy() : Destroying destroyed barrier.';
  STOP_REASON_SLV_BARRIER_DESTROY_IN_USE                         :Result:='ScePthreadBarrierDestroy() : Destroying barrier that is being used by any one of the threads.';
  STOP_REASON_SLV_POSIX_BARRIER_DESTROY_IN_USE                   :Result:='pthread_barrier_destroy() : Destroying barrier that is being used by any one of the threads.';
  STOP_REASON_SLV_BARRIER_WAIT_DESTROYED                         :Result:='ScePthreadBarrierWait() : Waiting destroyed barrier.';
  STOP_REASON_SLV_POSIX_BARRIER_WAIT_DESTROYED                   :Result:='pthread_barrier_wait() : Waiting destroyed barrier.';
  STOP_REASON_SLV_POSIX_MUTEX_TIMEDLOCK_DESTROYED                :Result:='Specified mutex is not valid.';
  STOP_REASON_SLV_POSIX_COND_TIMEDWAIT_DESTROYED                 :Result:='Specified condition variable is not valid.';
  STOP_REASON_SLV_POSIX_RWLOCK_TIMEDRDLOCK_DESTROYED             :Result:='Specified read / write lock is not valid.';
  STOP_REASON_SLV_POSIX_RWLOCK_TIMEDWRLOCK_DESTROYED             :Result:='Specified read / write lock is not valid.';
  else
   Result:='';
 end;
end;

